﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace http
{
    class Program
    {
        static String ResponeFormat =
        "HTTP/1.1 200 OK\r\n" +
        "Content-Length: {0}\r\n" +
        "Connection: close\r\n" +
        "Content-Type: text/html\r\n" +
        "\r\n" +
        "{1}\r\n";

        static void Main(string[] args)
        {
            Socket server = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            //在8000端口监听
            EndPoint ep = new IPEndPoint(new IPAddress(new byte[] { 127, 0, 0, 1 }), 8000);
            server.Bind(ep);
            server.Listen(5);

            while (true)
            {
                Socket client = server.Accept();

                //读取HTTP报文头部
                String header = String.Empty;
                while (header.IndexOf("\r\n\r\n") < 0)
                {
                    byte[] buffer = new byte[1024];
                    int len = client.Receive(buffer);
                    header += Encoding.ASCII.GetString(buffer, 0, len);
                }

                Console.WriteLine("================================================================================");
                Console.Write(header);

                Regex reg = new Regex(@"GET\s+([^\s\r\n]+)\s+HTTP/1.1\s*\r\n", RegexOptions.IgnoreCase);
                Match match = reg.Match(header);
                if (match.Success)
                {
                    String fname = Path.GetFileName(match.Groups[1].Value).ToLower();

                    if (fname == "index.htm")
                    {
                        String html = String.Format("<span style='color:red; fonst-size:24px;'>{0}</span>", DateTime.Now);
                        String response = String.Format(ResponeFormat, html.Length, html);

                        //发送HTTP回应，本次HTTP请求结束，浏览器将立刻接受到网页
                        client.Send(Encoding.UTF8.GetBytes(response));
                        client.Close();
                    }
                    else if (fname == "comet.htm")
                    {
                        //假设此时数据未准备好，先挂起链接，网页将在另一个线程中发送到浏览器
                        //在线程没有发送HTTP回应前，浏览器将一直等待，直到启动的线程发送回应
                        Thread thread = new Thread(new ParameterizedThreadStart(SendThreadEntry));
                        thread.Start(client);

                    }
                    else
                    {
                        client.Close();
                    }
                }
            }
        }

        static void SendThreadEntry(object data)
        {
            //等待5s
            Thread.Sleep(5000);
            Socket client = data as Socket;
            String html = String.Format("<span style='color:red; fonst-size:24px;'>{0}</span>", DateTime.Now);
            String response = String.Format(ResponeFormat, html.Length, html);

            Console.WriteLine("Send Response");

            //发送HTTP回应，本次HTTP请求结束，浏览器此时才接收到网页，在此之前浏览器一直等待
            client.Send(Encoding.UTF8.GetBytes(response));
            client.Close();
        }
    }
}
